<?php

/**
 * @class CreateController
 * Controls the browsing of the records
 */

Yii::import('xcruder.components.BaseController');

class PickerController extends BaseController
{

/**
 * Main render action, renders the form
 * GET params passed through:
 * 

$pickerModelClass
$dataProviderOptions
$selectableRows      0,1 or 2
$parentModelClass    we are browsing the relation of this class  (default: $_GET["modelClass"])
$parentPk            we are browsing the relation of this record (default: $_GET["modelPk"])
$modelRelationName   persistent param
$modelRelationClass  persistent param
[$fkFieldName]
 
 */

	public function getViewId() {

		$id = 'picker_' . $_GET['modelClass'] . '_' . $_GET['modelLevel'];
		
		if (isset($_GET['modelPk']))
			$id	.= preg_replace('/"/','',$_GET['modelPk']);
		
		if (isset($_GET['modelRelationName']))
			$id	.= $_GET['modelRelationName'];
		
		return $id;
	}

/**
 * Allows to select 
 * 
 **/ 
	public function actionIndex($opt = array()) {

		//Finding the rows for the grid - may requested for sorting, filtering
		
		$pickerModelClass = @$_GET['pickerModelClass'];
		$selectableRows = @$_GET['selectableRows'];

		//resident url params: 
		$modelRelationName = @$_GET['modelRelationName'];
		
		$dataProviderOptions = array();
		if ($selectableRows > 1) {
			$parentModel = @$_GET['parentModelClass'] ? XcruderActiveRecord::getModelFromRequestPk('parentModelClass', 'parentPk') : XcruderActiveRecord::getModelFromRequestPk();
			$dataProviderOptions['excludedRows'] = XcruderActiveRecord::safeArray(@$parentModel->$modelRelationName);
		}
		
		$opt = array_merge($_GET, array(
			'pickerModel' => XcruderActiveRecord::getSearchModel($pickerModelClass, @$_GET[$pickerModelClass]),
			'dataProviderOptions' => $dataProviderOptions
		));

		$this->renderPartial('index', $opt, false, true);

		if (Yii::app()->request->isAjaxRequest)
			Yii::app()->end();
	}


/**
 * 
 * 
 */
	public function actionAddRelated() {

		$modelRelationName = $_GET['modelRelationName'];
		$ids = @$_POST[@$_POST['selected_ids']];

		if ($modelRelationName && is_array($ids) && count($ids)>0) {
			
				$model = XcruderActiveRecord::getModelFromRequestPk();

				$relateds = $model->$modelRelationName;
				if (is_array($relateds))
					foreach($relateds as $related) {
						$ids[] = $related->getPrimaryKey();
					}

				//print_r( $rels[0]->getPrimaryKey() );
				//print_r($ids);
				
				$model->$modelRelationName = $ids;
				//if ($model->save())
				$model->updateRelated($modelRelationName);
		}
		
		$this->actionIndex();
	}

}
